'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _input = require('./input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Field = function (_Component) {
  _inherits(Field, _Component);

  function Field() {
    _classCallCheck(this, Field);

    return _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).apply(this, arguments));
  }

  _createClass(Field, [{
    key: 'failedValidations',


    // Utility Functions

    value: function failedValidations() {
      var currentValue = this.refs.element.value();
      return this.props.validations.filter(function (validation) {
        return !validation.func(currentValue);
      }).map(function (validation) {
        return validation.description;
      });
    }
  }, {
    key: 'name',
    value: function name() {
      return this.props.name;
    }
  }, {
    key: 'value',
    value: function value() {
      return this.refs.element.value();
    }

    // Hanlder Functions

  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      this.props.onChange(event, this);
    }

    // Render Helper Functions

  }, {
    key: 'fieldElementClass',
    value: function fieldElementClass() {
      return {
        'input': _input2.default
      }[this.props.fieldType];
    }
  }, {
    key: 'fieldElementProps',
    value: function fieldElementProps() {
      return {
        ref: 'element',
        name: this.props.name,
        placeholder: this.props.placeholder,
        onFormChange: this.props.onFormChange,
        onChange: this.handleChange.bind(this),
        defaultValue: this.props.defaultValue,
        password: this.props.password
      };
    }

    // Render Functions

  }, {
    key: 'render',
    value: function render() {
      var elementClass = this.fieldElementClass();
      var elementProps = this.fieldElementProps();
      return _react2.default.createElement(elementClass, elementProps);
    }
  }]);

  return Field;
}(_react.Component);

Field.defaultProps = {
  fieldType: 'input',
  dataType: 'string',
  validations: [],
  onChange: function onChange() {}
};


Field.propTypes = {
  name: _react2.default.PropTypes.string.isRequired,
  placeholder: _react2.default.PropTypes.string,
  fieldType: _react2.default.PropTypes.string,
  dataType: _react2.default.PropTypes.string,
  onFormChange: _react2.default.PropTypes.func
};

exports.default = Field;