'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _field = require('./field');

var _field2 = _interopRequireDefault(_field);

var _submit = require('./submit');

var _submit2 = _interopRequireDefault(_submit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormFactor = function (_Component) {
  _inherits(FormFactor, _Component);

  function FormFactor() {
    _classCallCheck(this, FormFactor);

    return _possibleConstructorReturn(this, (FormFactor.__proto__ || Object.getPrototypeOf(FormFactor)).apply(this, arguments));
  }

  _createClass(FormFactor, [{
    key: 'failedValidations',


    // Utility Functions

    value: function failedValidations() {
      return this.fields().map(function (field) {
        return {
          field: field.name(),
          validations: field.failedValidations()
        };
      }).filter(function (field) {
        return field.validations.length;
      });
    }
  }, {
    key: 'fields',
    value: function fields() {
      var _this2 = this;

      return this.fieldNames().map(function (fieldName) {
        return _this2.refs[fieldName];
      });
    }
  }, {
    key: 'fieldNames',
    value: function fieldNames() {
      return this.props.fields.map(function (field) {
        return field.name;
      });
    }
  }, {
    key: 'fieldValues',
    value: function fieldValues() {
      var values = {};
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.fieldNames()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var fieldName = _step.value;

          var field = this.refs[fieldName];
          values[fieldName] = field.value();
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return values;
    }

    // Handler Functions

  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      this.props.onChange(event);
    }
  }, {
    key: 'handleSubmit',
    value: function handleSubmit(event) {
      this.props.onSubmit(event);
    }

    // Render Functions

  }, {
    key: 'renderFields',
    value: function renderFields() {
      var _this3 = this;

      return this.props.fields.map(function (fieldProps, index) {
        fieldProps.key = index;
        fieldProps.ref = fieldProps.name;
        fieldProps.onFormChange = _this3.handleChange.bind(_this3);
        return _react2.default.createElement(_field2.default, fieldProps);
      });
    }
  }, {
    key: 'renderSubmit',
    value: function renderSubmit() {
      return _react2.default.createElement(_submit2.default, {
        submitButton: this.props.submitButton
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'form',
          {
            ref: 'form',
            onSubmit: this.handleSubmit.bind(this)
          },
          this.renderFields(),
          this.renderSubmit()
        )
      );
    }
  }]);

  return FormFactor;
}(_react.Component);

FormFactor.defaultProps = {
  onChange: function onChange() {},
  onSubmit: function onSubmit() {}
};


FormFactor.propTypes = {
  fields: _react2.default.PropTypes.array.isRequired,
  submit: _react2.default.PropTypes.object,
  onSubmit: _react2.default.PropTypes.func,
  onChange: _react2.default.PropTypes.func
};

exports.default = FormFactor;