import React, { Component } from 'react'

class Input extends Component {

  static defaultProps = {
    defaultValue: null,
    onChange: () => {},
  }

  // Lifecycle Functions

  constructor(props) {
    super(props)
    this.state = {
      value: this.props.defaultValue,
    }
  }

  // Utility FUnctions

  value() {
    return this.state.value
  }

  // Hanlder Funcitons

  handleChange(event) {
    const initialValue = this.state.value
    this.setState({
      value: event.target.value,
    }, () => {
      if (initialValue !== this.state.value) {
        this.handleChangeCallbacks(event)
      }
    })
  }

  handleChangeCallbacks(event) {
    this.props.onChange(event)
    this.props.onFormChange(event)
  }

  // Render Helper Functions

  inputType() {
    if (this.props.password) return 'password'
    else return ''
  }

  // Render Functions

  render() {
    return (
      <input
        onChange={this.handleChange.bind(this)}
        placeholder={this.props.placeholder}
        value={this.state.value}
        type={this.inputType()}
      />
    )
  }
}

Input.propTypes = {
  name: React.PropTypes.string.isRequired,
  onFormChange: React.PropTypes.func,
};

export default Input
